#include "SnakeUtility.h"

void setup(){
  pinMode(redPin,OUTPUT);
  pinMode(greenPin,OUTPUT);
  pinMode(bluePin,OUTPUT);
  pinMode(BUTTON_GameState, INPUT_PULLUP);
  pinMode(BUTTON_UP, INPUT_PULLUP);
  pinMode(BUTTON_RIGHT, INPUT_PULLUP);
  pinMode(BUTTON_LEFT, INPUT_PULLUP);
  pinMode(BUTTON_DOWN, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(BUTTON_GameState), BtnInterrupt, LOW);
  graphic_generate_characters();
  Game_MAIN();
  gameState = GAME_MENU;
}

void loop() {
  
  if(Interrupt){

         switch(gameState){
          case GAME_LOSE:
          gameState = GAME_NAMESCORE;
          Game_CHECKHIGHSCORES();
          break;
          case GAME_NAMESCORE:
          Game_HIGHSCORES();
          gameState = GAME_SCORES;
          break;
          case GAME_SCORES:
          Game_MAIN();
          gameState = GAME_MENU;
          break;
          case GAME_PLAY:
          gameState = GAME_LOSE;
          break;
          case GAME_MENU:
          Game_INIT();  
          break;
        }
        Interrupt = false;
 }
        
 if(digitalRead(BUTTON_UP) == pressed){
      if(debounce_activate_edge(&debCountBUTTON_UP)){
        snakeDirection=SNAKE_UP;
      }
  }else{
      debounce_deactivate(&debCountBUTTON_UP);
  }

  if(digitalRead(BUTTON_LEFT) == pressed){
      if(debounce_activate_edge(&debCountBUTTON_LEFT)){
        snakeDirection=SNAKE_LEFT;
      }
  }else{
      debounce_deactivate(&debCountBUTTON_LEFT);
  }

  if(digitalRead(BUTTON_DOWN) == pressed){
      if(debounce_activate_edge(&debCountBUTTON_DOWN)){
        snakeDirection=SNAKE_DOWN;
      }
  }else{
      debounce_deactivate(&debCountBUTTON_DOWN);
  }
  if(digitalRead(BUTTON_RIGHT) == pressed){
      if(debounce_activate_edge(&debCountBUTTON_RIGHT)){
        snakeDirection=SNAKE_RIGHT;
      }
  }else{
      debounce_deactivate(&debCountBUTTON_RIGHT);
  }
  
  if(millis()-lastGameUpdateTick>gameUpdateInterval){
    game_calculate_logic();
    game_calculate_display();
    graphic_clear();
    rgb_color();
    lastGameUpdateTick = millis();
    
  }
 }
